// TestDeviceLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestDeviceLib.h"
#include "TestDeviceLibDlg.h"
#include "DecLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDeviceLibDlg dialog

CTestDeviceLibDlg::CTestDeviceLibDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDeviceLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDeviceLibDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDeviceLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDeviceLibDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_BUTTON5, m_Display8253);
	DDX_Control(pDX, IDC_BUTTON4, m_Test8253);
	DDX_Control(pDX, IDC_BUTTON1, m_Test8255LoopBack);
	DDX_Control(pDX, IDC_BUTTON3, m_Status);
	DDX_Control(pDX, IDC_BUTTON2, m_Display);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDeviceLibDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDeviceLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDeviceLibDlg message handlers

BOOL CTestDeviceLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// 
	m_bTest8255 = FALSE;
	m_bTest8253 = FALSE;
    OpenDecPort();

	// get the I/O address
	//if(!GetDevicePortAddress(DECISION_PCI_8255_CARD, &m_usAddress))
	if(!GetDevicePortAddress(2, &m_usAddress))
	{
		AfxMessageBox("Get card address error!");
		EndDialog(-1);
	}
	m_nTimer = SetTimer(1, 1000, 0);

	///////////////////////////////////
	//
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDeviceLibDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDeviceLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDeviceLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// this function just for demo UI display
void CTestDeviceLibDlg::mydelay(void)
{
	int i,j, k =0;
	for( i =0; i < 1500; i++)
		for( j =0; j < 1500; j++)
			k++;	
}

void CTestDeviceLibDlg::test8255loopback(unsigned short ioport)
{
  int i, step = 0;
  static int loop = 0;
  unsigned char x1, x2, x3, y1, y2, y3, z1, z2, z3;
  unsigned long x;
  unsigned long y;
  unsigned duration = 64;
  CString str;

  if (!ioport)
    return;

  outportb (ioport + 3, 0x80);
  outportb (ioport + 7, 0x9b);

   for (i = 0; i < 24; i++) 
   {
      x = (unsigned long)1 << i;
      x1 = (unsigned char)(x & 0x00ff);
      x2 = (unsigned char)((x >> 8) & 0x00ff);
      x3 = (unsigned char)((x >> 16) & 0x00ff);
      y = 0x00800000 >> i;
      y1 = (unsigned char)(y & 0x00ff);
      y2 = (unsigned char)((y >> 8) & 0x00ff);
      y3 = (unsigned char)((y >> 16) & 0x00ff);
      outportb (ioport, x1);
      outportb (ioport + 1, x2);
      outportb (ioport + 2, x3);
      mydelay(); 
      z1 = inportb (ioport + 4);
      z2 = inportb (ioport + 5);
      z3 = inportb (ioport + 6);
      str.Format("Loop: %3d  Testing Pin:%2d  Output: %02X%02X%02X  Input:%02X%02X%02X  Correct:%02X%02X%02X",
	       loop + 1, i, x3, x2, x1, z3, z2, z1, y3, y2, y1);

	  m_Display.SetWindowText(str);

      if (z1 != y1 || z2 != y2 || z3 != y3) 
		m_Status.SetWindowText("Test Result : Error");
      else 
		m_Status.SetWindowText("Test Result : OK");
	}
	loop++;
	if(loop > 1000)
		loop = 0;
}


void CTestDeviceLibDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	m_bTest8255 = !m_bTest8255;

	if(m_bTest8255)
		m_Test8255LoopBack.SetWindowText("Stop Test 8255 Loopback");
	else
		m_Test8255LoopBack.SetWindowText("Start Test 8255 Loopback");

}

void CTestDeviceLibDlg::test8253(unsigned short ioport)
{
  static unsigned long loop = 0L;
  static BOOL bInitial = FALSE;
  unsigned duration = 4;
  int step = 0;
  unsigned cnt0 = 0, cnt1 = 0, cnt2 = 0;
  CString str;

  if(!bInitial)
  {
	outportb (ioport + 11, 0x30); //Counter 0: Mode 2, LSB + MSB
	outportb (ioport + 8, 1000 & 0x00ff);
	outportb (ioport + 8, (1000 >> 8) & 0x00ff);

	outportb (ioport + 11, 0x70); //Counter 1: Mode 2, LSB + MSB
	outportb (ioport + 9, 1000 & 0x00ff);
	outportb (ioport + 9, (1000 >> 8) & 0x00ff);

	outportb (ioport + 11, 0xb0); //Counter 2: Mode 2, LSB + MSB
	outportb (ioport + 10, 1000 & 0x00ff);
	outportb (ioport + 10, (1000 >> 8) & 0x00ff);  

	bInitial = TRUE;
  }

    cnt0 = inportb (ioport + 8) + (inportb (ioport + 8) << 8);
    cnt1 = inportb (ioport + 9) + (inportb (ioport + 9) << 8);
    cnt2 = inportb (ioport + 10) + (inportb (ioport + 10) << 8);
    str.Format("Loop: %8ld : counter: %6u %6u %6u", loop, cnt0, cnt1, cnt2);
    m_Display8253.SetWindowText(str);

	
	loop++;
	if(loop > 1000)
		loop = 0;

}

void CTestDeviceLibDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	m_bTest8253 = !m_bTest8253;

	if(m_bTest8253)
		m_Test8253.SetWindowText("Stop Test 8253 Loopback");
	else
		m_Test8253.SetWindowText("Start Test 8253 Loopback");
}

void CTestDeviceLibDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_bTest8255)
	{
		test8255loopback(m_usAddress);
	}

	if(m_bTest8253)
	{
		test8253(m_usAddress);
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CTestDeviceLibDlg::OnOK() 
{
	// TODO: Add extra validation here
	KillTimer(m_nTimer);   
    CloseDecPort();	
	CDialog::OnOK();
}

void CTestDeviceLibDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	KillTimer(m_nTimer);   
    CloseDecPort();	
	CDialog::OnCancel();
}

